#include <linux/cpu.h>

#ifndef register_hotcpu_notifier
	#ifdef CONFIG_HOTPLUG_CPU
		#define register_hotcpu_notifier(nb) register_cpu_notifier(nb)
	#else
		#define register_hotcpu_notifier(nb) do { } while(0)
	#endif
#endif

#ifndef unregister_hotcpu_notifier
	#ifdef CONFIG_HOTPLUG_CPU
		#define unregister_hotcpu_notifier(nb) unregister_cpu_notifier(nb)
	#else
		#define unregister_hotcpu_notifier(nb) do { } while(0)
	#endif
#endif

#include <linux/notifier.h>
#ifndef BLOCKING_NOTIFIER_HEAD
	#define BLOCKING_NOTIFIER_HEAD(name) struct notifier_block *name
	#define blocking_notifier_chain_register(head, nb) notifier_chain_register((head), (nb))
	#define blocking_notifier_chain_unregister(head, nb) notifier_chain_unregister((head), (nb))
	#define blocking_notifier_call_chain(head, val, v) notifier_call_chain((head), (val), (v))
#endif

#include <linux/version.h>
#if (LINUX_VERSION_CODE < KERNEL_VERSION(2,6,18))
#define DCA_CLASS_SLES_VERSION
#endif

#if (LINUX_VERSION_CODE < KERNEL_VERSION(2,6,27))
#define IOAT_BEFORE_KERNEL_2_6_27_PATCHES
#endif

#if (LINUX_VERSION_CODE < KERNEL_VERSION(2,6,28))
#define IOAT_BEFORE_KERNEL_2_6_28_PATCHES
#endif
