#ifndef _kaho_mod_h
#define _kaho_mod_h

#include <asm/ioctl.h>

#define KAHO_IOC_MAGIC 'k'

struct kaho_make_patch {
	pid_t target_pid;
	int nr_sub_patch;		/* number of the patch */
	int handle;
};

struct kaho_mem_opt {
	int handle;
	unsigned long req_addr;
	unsigned long req_size;
};

struct kaho_load_patch {
	int handle;
	int sub_patch_id;
	int patch_type;
	unsigned long src_addr;	  /* address of the patch in kaho command */
	unsigned long patch_addr; /* address to store the patch in the target */
	unsigned long patch_size; /* size of the patch code */
	unsigned long target_addr;/* address to be patched in the target */
};

struct kaho_std_opt {
	int handle;
	unsigned int flags;
};

struct kaho_get_info {
	int handle;
	int sub_patch_id;
	pid_t pid;
	int nr_sub_patch;
	int state;
	int patch_type;
	unsigned long patch_addr;
	unsigned long patch_size;
	unsigned long target_addr;
	int next_handle;
};


#define KAHOCTL_MAKE_PATCH	_IOWR(KAHO_IOC_MAGIC, 1, struct kaho_make_patch)
#define KAHOCTL_ALLOC_MEM	_IOWR(KAHO_IOC_MAGIC, 2, struct kaho_mem_opt)
#define KAHOCTL_LOAD_PATCH	_IOW (KAHO_IOC_MAGIC, 3, struct kaho_load_patch)
#define KAHOCTL_ACTIVATE	_IOW (KAHO_IOC_MAGIC, 4, struct kaho_std_opt)
#define KAHOCTL_ACTIVATE_RT	_IOW (KAHO_IOC_MAGIC, 5, struct kaho_std_opt)
#define KAHOCTL_DEACTIVATE	_IOW (KAHO_IOC_MAGIC, 6, struct kaho_std_opt)
#define KAHOCTL_FREE_MEM	_IOW (KAHO_IOC_MAGIC, 7, struct kaho_mem_opt)
#define KAHOCTL_DEL_PATCH	_IOW (KAHO_IOC_MAGIC, 8, struct kaho_std_opt)
#define KAHOCTL_GET_INFO	_IOWR(KAHO_IOC_MAGIC, 9, struct kaho_get_info)
#define KAHOCTL_CANCEL		_IOW (KAHO_IOC_MAGIC, 10, struct kaho_std_opt)

#define KAHO_STATE_ENTRY		0
#define KAHO_STATE_IN_ALLOC_MEM		1
#define KAHO_STATE_ALLOC_MEM_DONE	2
#define KAHO_STATE_IN_LOADING		3
#define KAHO_STATE_LOADING_DONE		4
#define KAHO_STATE_IN_ACT		5
//#define KAHO_STATE_IN_ACT_RT		6
#define KAHO_STATE_ACTIVE		7
#define KAHO_STATE_IN_DEACT		8
//#define KAHO_STATE_IN_DEACT_RT		9
#define KAHO_STATE_DEACTIVE		10
#define KAHO_STATE_IN_FREE_MEM		11
#define KAHO_STATE_FREE_MEM_DONE	12
#define KAHO_STATE_IN_DEL_PATCH		13
#define KAHO_STATE_IN_ACT_RT0		14
#define KAHO_STATE_IN_ACT_RT1		15
#define KAHO_STATE_IN_ACT_RT2		16
#define KAHO_STATE_IN_DEACT_RT0		17
#define KAHO_STATE_IN_DEACT_RT1		18
#define KAHO_STATE_IN_DEACT_RT2		19

#define KAHO_STATE_ERROR	-1

#define KAHO_MAX_NR_PATCH	0x1000
#define KAHO_MAX_NR_SUB		0x100


/* definition of patch type */
#define KAHO_PTYPE_UNKNOWN	0
#define KAHO_PTYPE_FUNC		1
#define KAHO_PTYPE_VAR		2
#define KAHO_PTYPE_POINTER	3
#define KAHO_PTYPE_MAX		4

/* flags for kaho_patch_item */
#define KAHO_X86_ABS_JMP	0x0001
#define KAHO_RT_PATCH		0x0002

#endif
