/*
 *  mazequeue_hash.h
 *
 *  Copyright (C) 2007-2008 MIRACLE LINUX Corp.
 *
 *	This program is free software; you can redistribute it and/or
 *	modify it under the terms of the GNU General Public License as
 *	published by the Free Software Foundation, version 2.
 */

#ifndef _LINUX_MAZEQUEUE_HASH_H
#define _LINUX_MAZEQUEUE_HASH_H

#ifdef __KERNEL__

#include <linux/list.h>
#include <linux/slab.h>
#include <linux/spinlock.h>
#include "maze.h"

struct maze_queue_entry
{
	struct maze_entry entry;
	struct hlist_node chain;
	struct list_head clist;
	unsigned long state;
	unsigned long command;
	unsigned long cpu;
	int in_slist;
	struct list_head slist;

#ifdef CONFIG_MAZEPROCDEBUG
	int nr;
#endif	
};

struct maze_queue_itr
{
	struct maze_queue *queue;
	struct hlist_node *curr;
	int hash_nr;
};

#endif /* __KERNEL__ */
#endif /* _LINUX_MAZEQUEUE_HASH_H */

